//**********************************************************************
// LCDPRINT.C
// Pic By Example
//
// (c) 2001 Sergio Tanzilli
// http://www.tanzilli.com
//
// Compiled with Borland Turbo C++ version 1.0
// (needs STCOM.C and STCOM.H header files)
//**********************************************************************

#include <conio.h>
#include <stdio.h>
#include <io.h>
#include <dos.h>
#include <process.h>
#include <stdlib.h>
#include <alloc.h>
#include <mem.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>

#include "stcom.h"

void ExitProg(int Rtc);

int nCom;

//**********************************************************************
// Main body
//**********************************************************************

void main(int argc,char *argv[])
{
  int i;

  char parameter[80];
  char OutputString[80];

  // Read command line options

  for (i=1;i<argc;i++) {
    strcpy(parameter,argv[i]);

    if (stricmp("/com1",parameter)==0) {
      nCom=ST_COM1;
      continue;
    }

    if (stricmp("/com2",parameter)==0) {
      nCom=ST_COM2;
      continue;
    }

    if (parameter[0]!='/') {
      strcpy(OutputString,parameter);
      continue;
    }

    printf("  Syntax error: use lcdprint [/com1 | /com2 ] string\n");
    exit(2);
  }

  if (nCom==-1 || argc<2) {
    printf("\n");
    printf("  Please use the following syntax:\n\n");
    printf("    lcdprint /com1 (or /com2) \"String to send\"\n\n");
    exit(0);
  }

  // Open COM port

  StOpenCom(nCom,9600,8,1,ST_NOPARITY);
  StSetTimeOut(nCom,500L);

  // Flush com buffer

  while (StComHit(nCom)!=0)
    StComGetChar(nCom);

  // Clear LCD

  StComPutChar(nCom,12);
  delay(50L);

  // Send the output sting to LCD

  for (i=0;i<strlen(OutputString);i++) {
    StComPutChar(nCom,OutputString[i]);
    delay(30L);
  }
  ExitProg(0);
}

//**********************************************************************
// Exit to DOS
//**********************************************************************

void ExitProg(int Rtc) {
  fcloseall();
  StCloseCom(nCom);
  exit(Rtc);
}

//**********************************************************************
// Exit to DOS in case of timeout on RS232 port
//**********************************************************************

void ExitForTimeout(void) {
  printf("\n  Timeout on port RS232. Abort\n");
  fcloseall();
  StCloseCom(nCom);
  exit(2);
}

